GNU bug report logs - #23546
25.1.50; scroll-restore-mode breaks comint-mode

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Dmitry Alexandrov <321942@HIDDEN>; dated Sun, 15 May 2016 23:29:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 23546 <at> debbugs.gnu.org:


Received: (at 23546) by debbugs.gnu.org; 3 Nov 2016 02:26:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 02 22:26:02 2016
Received: from localhost ([127.0.0.1]:41067 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1c27j7-0001Ez-ME
	for submit <at> debbugs.gnu.org; Wed, 02 Nov 2016 22:26:01 -0400
Received: from orbit.eternalimpact.info ([37.48.122.29]:44656)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anonyme@HIDDEN>)
 id 1c27EB-0000Uq-AJ
 for 23546 <at> debbugs.gnu.org; Wed, 02 Nov 2016 21:54:03 -0400
Received: from anonyme by orbit.eternalimpact.info with local (Exim 4.87)
 (envelope-from <anonyme@HIDDEN>)
 id 1c27E5-0008V9-6S
 for 23546 <at> debbugs.gnu.org; Thu, 03 Nov 2016 01:53:57 +0000
To: 23546 <at> debbugs.gnu.org
Subject: 
X-PHP-Script: anonymousemail.me/send.php for 128.252.25.50, 172.68.39.26
X-PHP-Originating-Script: 513:send.php
MIME-Version: 1.0
Content-Type: text/html; charset="utf-8"
From: <a@HIDDEN>
Subject: 
X-Mailer: Anonymous Email - https://anonymousemail.me
Message-Id: <E1c27E5-0008V9-6S@HIDDEN>
Date: Thu, 03 Nov 2016 01:53:57 +0000
X-AntiAbuse: This header was added to track abuse,
 please include it with any abuse report
X-AntiAbuse: Primary Hostname - orbit.eternalimpact.info
X-AntiAbuse: Original Domain - debbugs.gnu.org
X-AntiAbuse: Originator/Caller UID/GID - [513 523] / [47 12]
X-AntiAbuse: Sender Address Domain - orbit.eternalimpact.info
X-Get-Message-Sender-Via: orbit.eternalimpact.info: authenticated_id:
 anonyme/only user confirmed/virtual account not confirmed
X-Authenticated-Sender: orbit.eternalimpact.info: anonyme
X-Spam-Score: 2.7 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  thanks for the wonderful scroll-restore mode! the updated
 version here indeed fixes comint mode, but it appears to break macros in the
 same way for me as well (in evil mode, for what it's worth): replaying a
 macro that changes a word to "input" (`cwinput`) gives "putni" instead of
 input [...] 
 Content analysis details:   (2.7 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.6 RCVD_IN_BRBL_LASTEXT   RBL: No description available.
 [37.48.122.29 listed in bb.barracudacentral.org]
 0.0 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level mail
 domains are different
 -2.7 RP_MATCHES_RCVD Envelope sender domain matches handover relay domain
 0.0 HTML_MESSAGE           BODY: HTML included in message
 1.1 MIME_HTML_ONLY         BODY: Message only has text/html MIME parts
 2.0 BLANK_SUBJECT          Subject is present but empty
 0.6 HTML_MIME_NO_HTML_TAG  HTML-only message, but there is no HTML tag
X-Debbugs-Envelope-To: 23546
X-Mailman-Approved-At: Wed, 02 Nov 2016 22:26:00 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.7 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  thanks for the wonderful scroll-restore mode! the updated
   version here indeed fixes comint mode, but it appears to break macros in the
    same way for me as well (in evil mode, for what it's worth): replaying a
   macro that changes a word to "input" (`cwinput`) gives "putni" instead of
   input [...] 
 
 Content analysis details:   (2.7 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  1.6 RCVD_IN_BRBL_LASTEXT   RBL: No description available.
                             [37.48.122.29 listed in bb.barracudacentral.org]
  0.0 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level mail
                             domains are different
 -2.7 RP_MATCHES_RCVD        Envelope sender domain matches handover relay domain
  0.0 HTML_MESSAGE           BODY: HTML included in message
  1.1 MIME_HTML_ONLY         BODY: Message only has text/html MIME parts
  2.0 BLANK_SUBJECT          Subject is present but empty
  0.6 HTML_MIME_NO_HTML_TAG  HTML-only message, but there is no HTML tag

<p>thanks for the wonderful scroll-restore mode!</p>

<p>the updated version here indeed fixes comint mode, but it appears to break macros in the same way for me as well (in evil mode, for what it&#39;s worth):</p>

<p>replaying a macro that changes a word to &quot;input&quot; (`cwinput`) gives &quot;putni&quot; instead of input</p>

<p>fortunately that&#39;s the only new bug I&#39;ve noticed so far</p>





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23546; Package emacs. Full text available.

Message received at 23546 <at> debbugs.gnu.org:


Received: (at 23546) by debbugs.gnu.org; 22 May 2016 01:34:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 21 21:34:11 2016
Received: from localhost ([127.0.0.1]:60294 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4IHT-0007ZF-49
	for submit <at> debbugs.gnu.org; Sat, 21 May 2016 21:34:11 -0400
Received: from mail-lb0-f174.google.com ([209.85.217.174]:36198)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <321942@HIDDEN>) id 1b4IHR-0007Z1-6g
 for 23546 <at> debbugs.gnu.org; Sat, 21 May 2016 21:34:09 -0400
Received: by mail-lb0-f174.google.com with SMTP id h1so45804835lbj.3
 for <23546 <at> debbugs.gnu.org>; Sat, 21 May 2016 18:34:09 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=subject:references:to:from:message-id:date:user-agent:mime-version
 :in-reply-to:content-transfer-encoding;
 bh=dN7JsB0uwkdDQ86ULVJ4t5gxaDbanhZipq4FMUbT8m0=;
 b=RFikIEcB2AfNPEXUyjyxwrlbsy8gvo84+gnIxpjYoQyMIkKAknOnFJLnvRjGp3LNQG
 WkyqrUT9Zt/kNlEnAq/A9KHAjY2ucxyhC522PIfUWUmXBGstnuvJDB+3m+/SJeKShYCr
 3ZRE9DJI5Va/+6RtpASn78y/t4cy3FusCKGgomcCSBNKxHIp4GhmHwUqrNtnpteNUq7K
 ZkDZ0wMnNmBmf99huMeiyKy1pyzyLyjk3wVDyd3yIeRuWOzXtj7iQt4o/wMeGEVGnLqX
 E57HcwoPpGFR0oxEyC/4/8CmO1Mn2IdZtaEAxkBtDmw0w710oracl1UDkufvGXJBc/WQ
 qXVQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:subject:references:to:from:message-id:date
 :user-agent:mime-version:in-reply-to:content-transfer-encoding;
 bh=dN7JsB0uwkdDQ86ULVJ4t5gxaDbanhZipq4FMUbT8m0=;
 b=ioYOyjhc5jHk0ewsXIcopqUlAGX9fqm+ZdieQMJoc0YC8n0v5enn9Li9Pr+PJ0ywqU
 UXHgIlSY0uMB2+fIflvdr2pg00v2LPR6ZyxIzr4jUWyGLoZTxRgmAVghoyKV/6z3xBf4
 ODeRS0YSMwZNdgCjzYco5J65hQDtyVCj9RaP2yT3zRew8o6qHf9AnXDFZZ/ZppiSyT5D
 2qanVsjDnZyKzKoIXiY0XDn7k5c2NadXFqGzj4ciuJrYOB4pIG+KdwaCIZomt9VIkS+x
 8BUivkOm9ZtCiCFwZ+Kup2u4qMByLqE3A6LUrYMo+BYwL2uFAiJ9Xxw4gA4aib3+z1Ce
 JJZw==
X-Gm-Message-State: AOPr4FV3GGw8QlyCxXDG3G6P0NUGmAgib9RrFzgL7JkNTckyL4IDb5uUa/fW9IUX2MvEaw==
X-Received: by 10.112.124.228 with SMTP id ml4mr2967416lbb.113.1463880842901; 
 Sat, 21 May 2016 18:34:02 -0700 (PDT)
Received: from [192.168.1.132] ([178.218.27.218])
 by smtp.googlemail.com with ESMTPSA id j97sm256218lfi.5.2016.05.21.18.34.01
 (version=TLSv1/SSLv3 cipher=OTHER);
 Sat, 21 May 2016 18:34:01 -0700 (PDT)
Subject: Re: bug#23546: 25.1.50; scroll-restore-mode breaks comint-mode
References: <5738CD38.7030907@HIDDEN> <573982E5.9020005@HIDDEN>
 <573B58B9.50409@HIDDEN> <573C1342.1040408@HIDDEN>
 <573CB90D.3030808@HIDDEN> <573DB806.8020005@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>, 23546 <at> debbugs.gnu.org
From: Dmitry Alexandrov <321942@HIDDEN>
Message-ID: <57410CA6.4070401@HIDDEN>
Date: Sun, 22 May 2016 04:34:30 +0300
User-Agent: Mozilla/5.0 (X11; GNU x86_64; rv:31.0) Gecko/20100101
 Icedove/31.3.0
MIME-Version: 1.0
In-Reply-To: <573DB806.8020005@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.5 (/)
X-Debbugs-Envelope-To: 23546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 19/05/16 15:56, martin rudalics wrote:
>> Hmm...  Probably I completely missed the point, but is not
>> ‘scroll-restore-jump-back’ an option that enables the title
>> functionality of scroll-restore-mode — restoring the point position
>> after scrolling, thus simulating the behaviour of most editors, which
>> does not have that limitation of Emacs — that cursor position can be
>> on-screen only.
>
> The aim of ‘scroll-restore-mode’ was much more modest: To move the
> cursor to the position of ‘window-point’ after a sequence of scroll
> commands have made that position invisible and then visible again.
>
> ‘scroll-restore-jump-back’ is much more aggressive: It forces the
> position of ‘window-point’ to become visible again and move the cursor
> to it after the first command which is not part of a sequence of scroll
> commands that have made that position invisible.  If you are used to the
> behavior of "most editors" where such behavior is the default, you might
> like this.
>
> Note, however, that the behavior I just described is not precisely the
> behavior of these editors because, in addition to moving window-point
> when it is scrolled off-screen, Emacs may also move window-point when it
> enters the scroll margin.  Such movement is left alone by my algorithm.

Thank you for explanation.

>> How would you recommend to use it?  To write an advice around ‘keyboard-quit’ (like below), so scrolling would be ‘cancelled’ only with ‘C-g’?
>>
>> (defadvice keyboard-quit (before scroll-restore-jump-back activate)
>>    (scroll-restore-jump-back))
>>
>
> It depends on what precisely you want to accomplish (or what you are
> used to).  But why on earth would you want to advise ‘keyboard-quit’?

To make ‘C-g’ and other keys that I bound to ‘keyboard-quit’ to ‘quit’ 
scrolling (if I may say so) too, of course.  Should I redefine these 
keys instead?

>>> I'll attach my latest version of ‘scroll-restore-mode’.  Please try it.
>>> If you confirm that this version works
>>
>> Yes.  My appreciations to you.
>>
>>> and doesn't break anything else,
>>
>> I could not try anything, of course, but at first sight it does not.
>
> All you have to do is use it for a sufficient amount of time.  I'm
> confident that there are unresolved issues left.

And you are right.  There is one of them: now it breaks macros that 
involve isearch.  Suppose that macro:

C-x ( C-s sit RET SPC bar C-x )

By executing it on a line:

¦Lorem ipsum dolor sit amet.

instead of:

Lorem ipsum dolor sit bar¦ amet.

I get:

r¦ab Lorem ipsum dolor sit amet.

(‘¦’ denotes point).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23546; Package emacs. Full text available.

Message received at 23546 <at> debbugs.gnu.org:


Received: (at 23546) by debbugs.gnu.org; 19 May 2016 12:56:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 19 08:56:50 2016
Received: from localhost ([127.0.0.1]:57700 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b3NVR-0006GA-SG
	for submit <at> debbugs.gnu.org; Thu, 19 May 2016 08:56:50 -0400
Received: from mout.gmx.net ([212.227.15.18]:53363)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1b3NVQ-0006Fx-3Z
 for 23546 <at> debbugs.gnu.org; Thu, 19 May 2016 08:56:48 -0400
Received: from [192.168.1.101] ([212.95.7.103]) by mail.gmx.com (mrgmx003)
 with ESMTPSA (Nemesis) id 0M3AWN-1btI0E34ml-00swvw; Thu, 19 May 2016 14:56:41
 +0200
Message-ID: <573DB806.8020005@HIDDEN>
Date: Thu, 19 May 2016 14:56:38 +0200
From: martin rudalics <rudalics@HIDDEN>
MIME-Version: 1.0
To: Dmitry Alexandrov <321942@HIDDEN>, 23546 <at> debbugs.gnu.org
Subject: Re: bug#23546: 25.1.50; scroll-restore-mode breaks comint-mode
References: <5738CD38.7030907@HIDDEN> <573982E5.9020005@HIDDEN>
 <573B58B9.50409@HIDDEN> <573C1342.1040408@HIDDEN>
 <573CB90D.3030808@HIDDEN>
In-Reply-To: <573CB90D.3030808@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K0:SpOghhnUqPqLWooza/AOaVGXmuFkq2Lna1RXpePcKr83j5zLG+M
 gOkKh5Pt+Ez1NHD1mZnW///L/BgvXYraf48NHHZJP86752H1z80YnoDR+H+txM9girL8a8D
 g9L6ejhVhmxxSDe2vA8ZhN9W6qPbqUJnmf5+zDPKD0zZO79SatrgPwriUELrNdlrkHBRFzK
 j2C0VoPGtX7PU3H880x+Q==
X-UI-Out-Filterresults: notjunk:1;V01:K0:rMoYyI69F2g=:cjSe+DdFys9e4Lk9PUqcIQ
 bkIMGeecPoNLxCqbuhYWiWvrzyB7/up4TU4+OBQccplkZJn0tPi0W64UpinvP/El9znBq57dm
 TV8SC3OnZgtCnK1kRnM3TWFzXvUqYXhMPlCIgNIUktCtXPDqXgWZlWTSRq/PFlkbYrbARspw0
 f6jadNNERsmLwiynhUneI+zlix7Bw1SPITVzKc4V0isZ4IP/+pEIzKRP/xqsWLsy7LrLPGviL
 5Cs1x8+tOiAa4VBxvmzlVn7mLqRzstIdFRWt1/Tpu4vML8bQw9VpAOEK/4qEt49F0/Bgz8Mz9
 dB+Vz6LhIyBaP4Cb47UfCqGteBU9QqhljFrYVmlZ7bZbpANY5lwLmmIyoWz0/dR7oQ5REV7+s
 euwc/DfmA6kru0Al4czfpNuCHTWOD17uthnSROOY8iKHQjJR/ZMc1dO0s25qvIB2y4EVJ7lSq
 jG84k6bwDyU1QEpBlRW3bNcLFJz3YGrDBdeCRvWo2pz5FDmlhsUMkGwVsutDYoF9Klxijdtfj
 /TQFqjeW78qfdhrf9idOpn3HZQhToZyKn7INcW5O1o75B+fsCb0bz5DV3LFtg6fcneZ9f7RKy
 DJyPfvrs1avfvgh1ojouO8pRntSrGip9kc0qZOztKw2SIEu8cBEIBBZ8/834YFg8Jyl8NC9/+
 OxROhxCXu7ReI9pcXzrMq6zGMGR+lqDhAY0CXkSbCDiCU05QDnUoOd6CWZs+Bn6GFWpFVWeCB
 pEw4JnfOQREcOpD2afLMjlYLRGjiK/ogzLJJtuNiuhyyF/4l7xsmduA24vliKYfJFJA0WUL39
 j4d1wnlwXjlo7bpIGpFHsSZgYzzdw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 23546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

 > Hmm...  Probably I completely missed the point, but is not
 > =E2=80=98scroll-restore-jump-back=E2=80=99 an option that enables the =
title
 > functionality of scroll-restore-mode =E2=80=94 restoring the point pos=
ition
 > after scrolling, thus simulating the behaviour of most editors, which
 > does not have that limitation of Emacs =E2=80=94 that cursor position =
can be
 > on-screen only.

The aim of =E2=80=98scroll-restore-mode=E2=80=99 was much more modest: To=
 move the
cursor to the position of =E2=80=98window-point=E2=80=99 after a sequence=
 of scroll
commands have made that position invisible and then visible again.

=E2=80=98scroll-restore-jump-back=E2=80=99 is much more aggressive: It fo=
rces the
position of =E2=80=98window-point=E2=80=99 to become visible again and mo=
ve the cursor
to it after the first command which is not part of a sequence of scroll
commands that have made that position invisible.  If you are used to the
behavior of "most editors" where such behavior is the default, you might
like this.

Note, however, that the behavior I just described is not precisely the
behavior of these editors because, in addition to moving window-point
when it is scrolled off-screen, Emacs may also move window-point when it
enters the scroll margin.  Such movement is left alone by my algorithm.

 > How would you recommend to use it?  To write an advice around =E2=80=98=
keyboard-quit=E2=80=99 (like below), so scrolling would be =E2=80=98cance=
lled=E2=80=99 only with =E2=80=98C-g=E2=80=99?
 >
 > (defadvice keyboard-quit (before scroll-restore-jump-back activate)
 >    (scroll-restore-jump-back))
 >

It depends on what precisely you want to accomplish (or what you are
used to).  But why on earth would you want to advise =E2=80=98keyboard-qu=
it=E2=80=99?

 >> I'll attach my latest version of =E2=80=98scroll-restore-mode=E2=80=99=
=2E  Please try it.
 >> If you confirm that this version works
 >
 > Yes.  My appreciations to you.
 >
 >> and doesn't break anything else,
 >
 > I could not try anything, of course, but at first sight it does not.

All you have to do is use it for a sufficient amount of time.  I'm
confident that there are unresolved issues left.

martin





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23546; Package emacs. Full text available.

Message received at 23546 <at> debbugs.gnu.org:


Received: (at 23546) by debbugs.gnu.org; 18 May 2016 18:48:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 18 14:48:33 2016
Received: from localhost ([127.0.0.1]:57259 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b36WH-0007gH-Bg
	for submit <at> debbugs.gnu.org; Wed, 18 May 2016 14:48:33 -0400
Received: from mail-lb0-f181.google.com ([209.85.217.181]:36847)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <321942@HIDDEN>) id 1b36WG-0007g5-3N
 for 23546 <at> debbugs.gnu.org; Wed, 18 May 2016 14:48:32 -0400
Received: by mail-lb0-f181.google.com with SMTP id h1so20710660lbj.3
 for <23546 <at> debbugs.gnu.org>; Wed, 18 May 2016 11:48:31 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=subject:references:to:from:message-id:date:user-agent:mime-version
 :in-reply-to:content-transfer-encoding;
 bh=UXuR5n2JiqEyXiXYCpccx0liivzTd2VByYT+QKCr6zM=;
 b=l++s/Pb1U8yYos2dEt1g7uKRRvxn2oXbBDKDJoNPW+8xFG8NVdWqq5dNys9nKDdK5l
 A+R57SppxzMbYVqlLDNGtTKmygTQidz5MsMpI60jcBDSpA5H3snL61p98a0QtHB26PRH
 bxOkL13uucvjJEUUUPX5x/9DL3GqfOoRf3P1t1Bt+1JqPCm+WkMTI4XUXkdk45pO2RvW
 49kGnqWrc2U3Z/FN1xIEm0LUaxQFAP8j4W72FFnotuSrj98TkW1hbP8dEErenbZI5ki/
 TUF/FpyFeLe9/n8xlb0huqa8d1lRAZZzQcQSxSkAofY937OlLP3nd7XpDGunuNG5uaxK
 NBFQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:subject:references:to:from:message-id:date
 :user-agent:mime-version:in-reply-to:content-transfer-encoding;
 bh=UXuR5n2JiqEyXiXYCpccx0liivzTd2VByYT+QKCr6zM=;
 b=dvwM6Kp1MJd6KaYXI2z5Sqa8F5KLrC9Or5KHgP+cRHfpj1mkBxE1MUTczIMk2s6lSl
 lMmT0DlFRQN5Fc4eoLlugsacjmuX/5rXN13xF1JO2+wBc1OI30D/f0UBsHDoUHPu7lvN
 68X68k3hhwHMvRome8A0DWPHGkDDHizZtE2RVsG1D1a9u90Yj7oDgE08ajHxAQ/0KWqj
 9O3SryiLq4TVERlhrEBwk6MCAtSsQckJYyOmW0b/eC2kNl5uzl2U9GOIfy3E8+s/iN2F
 k40+JOHZ33VpD6kY7yoVS2ZVzKCF0VTsStIZ4L8Mr2VQz0Up29hFocn5qc84aXLZqaBv
 aH4Q==
X-Gm-Message-State: AOPr4FUFKotJJp4je2Tasg67V9yIggUVU4mcvgo7WFCDLnIuY3afwEN3bUXqgIIt58mJQg==
X-Received: by 10.112.26.172 with SMTP id m12mr3124485lbg.44.1463597306018;
 Wed, 18 May 2016 11:48:26 -0700 (PDT)
Received: from [192.168.1.132] ([178.218.27.218])
 by smtp.googlemail.com with ESMTPSA id h9sm1617653lfg.3.2016.05.18.11.48.24
 (version=TLSv1/SSLv3 cipher=OTHER);
 Wed, 18 May 2016 11:48:24 -0700 (PDT)
Subject: Re: bug#23546: 25.1.50; scroll-restore-mode breaks comint-mode
References: <5738CD38.7030907@HIDDEN> <573982E5.9020005@HIDDEN>
 <573B58B9.50409@HIDDEN> <573C1342.1040408@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>, 23546 <at> debbugs.gnu.org
From: Dmitry Alexandrov <321942@HIDDEN>
Message-ID: <573CB90D.3030808@HIDDEN>
Date: Wed, 18 May 2016 21:48:45 +0300
User-Agent: Mozilla/5.0 (X11; GNU x86_64; rv:31.0) Gecko/20100101
 Icedove/31.3.0
MIME-Version: 1.0
In-Reply-To: <573C1342.1040408@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.5 (/)
X-Debbugs-Envelope-To: 23546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 18/05/16 10:01, martin rudalics wrote:
>>> Could you try with ‘comint-scroll-to-bottom-on-input’ set to 'this?
>>> That option apparently conflicts with ‘scroll-restore-jump-back’.
>>
>> Yes, this option does force any input to be typed at the
>> end-of-buffer, of course.  However, the possibility to ‘C-r’ back,
>> edit some command in-place and hit ‘RET’ — i. e. the possibility that
>> this option disables — is exactly why I prefer shell-mode over a
>> full-featured terminal emulator.
>
> I still don't understand what you need ‘scroll-restore-jump-back’ for.
> But I have to admit that I don't even remember the purpose of that
> option well :-(

Hmm...  Probably I completely missed the point, but is not 
‘scroll-restore-jump-back’ an option that enables the title 
functionality of scroll-restore-mode — restoring the point position 
after scrolling, thus simulating the behaviour of most editors, which 
does not have that limitation of Emacs — that cursor position can be 
on-screen only.

How would you recommend to use it?  To write an advice around 
‘keyboard-quit’ (like below), so scrolling would be ‘cancelled’ only 
with ‘C-g’?

(defadvice keyboard-quit (before scroll-restore-jump-back activate)
   (scroll-restore-jump-back))

>>> I'm afraid that ‘scroll-restore-mode’ is too simplistic in this regard.
>>
>> Alas.
>
> I'll attach my latest version of ‘scroll-restore-mode’.  Please try it.
> If you confirm that this version works

Yes.  My appreciations to you.

> and doesn't break anything else,

I could not try anything, of course, but at first sight it does not.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23546; Package emacs. Full text available.

Message received at 23546 <at> debbugs.gnu.org:


Received: (at 23546) by debbugs.gnu.org; 18 May 2016 07:01:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 18 03:01:56 2016
Received: from localhost ([127.0.0.1]:56469 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b2vUS-00065A-8R
	for submit <at> debbugs.gnu.org; Wed, 18 May 2016 03:01:56 -0400
Received: from mout.gmx.net ([212.227.17.20]:56097)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1b2vUQ-00064x-Bj
 for 23546 <at> debbugs.gnu.org; Wed, 18 May 2016 03:01:54 -0400
Received: from [192.168.1.100] ([212.95.7.115]) by mail.gmx.com (mrgmx102)
 with ESMTPSA (Nemesis) id 0MUm1o-1b47nT3mqy-00YApZ; Wed, 18 May 2016 09:01:48
 +0200
Message-ID: <573C1342.1040408@HIDDEN>
Date: Wed, 18 May 2016 09:01:22 +0200
From: martin rudalics <rudalics@HIDDEN>
MIME-Version: 1.0
To: Dmitry Alexandrov <321942@HIDDEN>, 23546 <at> debbugs.gnu.org
Subject: Re: bug#23546: 25.1.50; scroll-restore-mode breaks comint-mode
References: <5738CD38.7030907@HIDDEN> <573982E5.9020005@HIDDEN>
 <573B58B9.50409@HIDDEN>
In-Reply-To: <573B58B9.50409@HIDDEN>
Content-Type: multipart/mixed; boundary="------------070208020304090709000404"
X-Provags-ID: V03:K0:ghnd2/MF5GEZb/jiw02Y3PFH5FnM/9A6mAj+zmn9HxntDs9lgKM
 q+BtwYDn2tBvgCNcFFyfUrKOQb3bMzlT5GbixglYe+wNkksD28Yxhpr7Fy2Tfdbx2xncz7l
 s83bGc50XyoK1qkjk3rzxKibXYfRrf82F9fnn7ulcN09C01Svu9MvqTNtuG/qUsKMlu8Twk
 OJ5Aen68/85SQx0Oj71Kg==
X-UI-Out-Filterresults: notjunk:1;V01:K0:P8DuXmYnmco=:t4Vk467Z1P7rMrGjoMiAuS
 yTcbkAgx1i4ckmPL+Ey0E1i9FngQfOVOUeX4u3OnTbToNTFiDRCeBfTwS5MkxCWdwD1F2D9Ei
 KD2E9iqtUlAuCYvkZhNB6JSTr1GoB0oksONBzlwTdgmwUwZg3lYXfVidKu7r5N3hHwTtGiSnd
 yMjZ9kKiiOyZaQ8N8YAMByFrytUhqrGQ5cmz81Tsom9P9cMP4lMpyfSzKjERxU+KZgo4FQJzS
 hekDUCPpu03u8tDra0x3VBFu2Dqeko2X71TDEPrwbCh1Y3fbhJgKliWHBc8bK9bviUsfVJTe+
 dGNxXAkW2ug4acHVmZNUw9KErl0TBatH8/hOZKj2nqJ3lFW7bx/gpHnO5/LfQlYyGsz5jCiL9
 aNvhJhvJsi503u4kTECoDUXuVKBLe3cBcNQNeQ9spW8P91wiO/6wDvF6WjZtvFBXZDi4C8zHf
 2XYHHOeMJF8pqdOXpYCR9uK1CSdleYbcNz3F9taiN5z+QuIVb6r76GcdObfsm2wUUkYoIrGKc
 6K+x8l3iEPRbCom7OFYTJVNoZa+j1fCiWTdakLbdk4oXePGuqRraUuiG/9+l2RI9VsglaYDfI
 T5pWeWjFIz7CGSznmcQCFKVtzh2y0RCHG1qbWvr2TnB2PrqhwSMYpk6zmdolkXYtAjBo0WouN
 cbq+OnN+jck9boIE/tcnxSUoc+HHGKo698YsnAwyG2KP/nGs4vCZ22yYST8twlt/gIBfMEB9H
 E5e6bV4rCdpY2YbxZtmaFkQFPx8wBA76Sx9ZdPnifdDYOWfxtGTFZ8AUjhk8VkbQAsYjKkE8B
 9TV9LoKbFQqo8138yVJEg2TleN7nw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 23546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

This is a multi-part message in MIME format.
--------------070208020304090709000404
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: quoted-printable

 >> Could you try with =E2=80=98comint-scroll-to-bottom-on-input=E2=80=99=
 set to 'this?
 >> That option apparently conflicts with =E2=80=98scroll-restore-jump-ba=
ck=E2=80=99.
 >
 > Yes, this option does force any input to be typed at the
 > end-of-buffer, of course.  However, the possibility to =E2=80=98C-r=E2=
=80=99 back,
 > edit some command in-place and hit =E2=80=98RET=E2=80=99 =E2=80=94 i. =
e. the possibility that
 > this option disables =E2=80=94 is exactly why I prefer shell-mode over=
 a
 > full-featured terminal emulator.

I still don't understand what you need =E2=80=98scroll-restore-jump-back=E2=
=80=99 for.
But I have to admit that I don't even remember the purpose of that
option well :-(

 >> I'm afraid that =E2=80=98scroll-restore-mode=E2=80=99 is too simplist=
ic in this regard.
 >
 > Alas.

I'll attach my latest version of =E2=80=98scroll-restore-mode=E2=80=99.  =
Please try it.
If you confirm that this version works and doesn't break anything else,
I can install the appropriate changes in the elpa version.

Thanks, martin

--------------070208020304090709000404
Content-Type: application/emacs-lisp;
 name="scroll-restore.el"
Content-Transfer-Encoding: base64
Content-Disposition: attachment;
 filename="scroll-restore.el"
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--------------070208020304090709000404--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23546; Package emacs. Full text available.

Message received at 23546 <at> debbugs.gnu.org:


Received: (at 23546) by debbugs.gnu.org; 17 May 2016 17:45:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 17 13:45:17 2016
Received: from localhost ([127.0.0.1]:56197 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b2j3U-0004K0-RM
	for submit <at> debbugs.gnu.org; Tue, 17 May 2016 13:45:17 -0400
Received: from mail-lb0-f180.google.com ([209.85.217.180]:34091)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <321942@HIDDEN>) id 1b2j3Q-0004BJ-S4
 for 23546 <at> debbugs.gnu.org; Tue, 17 May 2016 13:45:15 -0400
Received: by mail-lb0-f180.google.com with SMTP id n11so8735017lbh.1
 for <23546 <at> debbugs.gnu.org>; Tue, 17 May 2016 10:45:12 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=subject:references:to:from:message-id:date:user-agent:mime-version
 :in-reply-to:content-transfer-encoding;
 bh=pm/yLDXjCm6KXfcHHG00oszYcrrWUiG1ViMan6npxdA=;
 b=lCrZv8PTOqKgwZmsPf1ZnSmDeDoe+O0boy5SUlix6t1mYCxHG996GCf0VjiIHoIP5w
 Xf8u6HcRW5Bl9o8PCGLjA2A2jJ/CKdgXP3v3IdKWjF1PUrNHiyWdxsttT43T5ehk/ErO
 6aMjd2Yfm2VLqXi9cGlFKoGKOhn0pCLaEuNgLKc9BSfzttk6B5OPNDUMO73S7MOKtdhw
 VoSqlUJ5wAur4DYkw3nCnce6sJyPMdLoF7e2pPG28etZPfzQFJY1NDzE27mf1Hf727f1
 Zb7TSglUjELEks432MNTfSkDRpouQGkFuC/xZix3JH7ZzGr+HNZAryP1fBCzvMf1rrt5
 IDsg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:subject:references:to:from:message-id:date
 :user-agent:mime-version:in-reply-to:content-transfer-encoding;
 bh=pm/yLDXjCm6KXfcHHG00oszYcrrWUiG1ViMan6npxdA=;
 b=PCNvxz5bYt3RgrVCzwi3yvCaxbnOmAa7LIrYwTWodNi+Za4U5DG0Hxw4ju9n/wZ/mj
 lOE8mZ+lPZX9gWDR525HLDCkhhkHkk5a/EKhINe8pi77lcLckLPMz48i/VzpAwQPcHel
 MUe++IqtsP45jkVyF78U90YhODnPyTlnXJKWagZGfpEdy9ATCkX8mw1pPNoDy1KJgw3c
 Qn1cFQhh228wRl9fjtpwN7BqyH6bs6oh+GC9Fxf0of58clw0PrHDotdpSA5LNPsHmx7d
 g5v6AEwHpYEXlWnqCzAOTYt5cgVIhJvJa+TmjA5+yjZlbXKatV3UWJ6J4RDyELusJc9L
 HXtA==
X-Gm-Message-State: AOPr4FUDylsvQhhPeTa2vYj6RIbzHXppwiDOpR5Kdojb47SHYQOiY7g3tM0qfG4TMNaekg==
X-Received: by 10.112.180.233 with SMTP id dr9mr980492lbc.11.1463507106850;
 Tue, 17 May 2016 10:45:06 -0700 (PDT)
Received: from [192.168.1.132] ([178.218.27.218])
 by smtp.googlemail.com with ESMTPSA id l125sm709960lfe.5.2016.05.17.10.45.05
 (version=TLSv1/SSLv3 cipher=OTHER);
 Tue, 17 May 2016 10:45:05 -0700 (PDT)
Subject: Re: bug#23546: 25.1.50; scroll-restore-mode breaks comint-mode
References: <5738CD38.7030907@HIDDEN> <573982E5.9020005@HIDDEN>
To: 23546 <at> debbugs.gnu.org, martin rudalics <rudalics@HIDDEN>
From: Dmitry Alexandrov <321942@HIDDEN>
Message-ID: <573B58B9.50409@HIDDEN>
Date: Tue, 17 May 2016 20:45:29 +0300
User-Agent: Mozilla/5.0 (X11; GNU x86_64; rv:31.0) Gecko/20100101
 Icedove/31.3.0
MIME-Version: 1.0
In-Reply-To: <573982E5.9020005@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.5 (/)
X-Debbugs-Envelope-To: 23546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 16/05/16 11:20, martin rudalics wrote:
>> I encountered a problem that looks like a bug to me: scroll-restore-mode
>> (from elpa.gnu.org [0]) breaks comint-mode (built-in, GNU Emacs 25.1.50.1).
>>
>> [0] https://elpa.gnu.org/packages/scroll-restore.html
>>
>> Steps to reproduce in a clear environment:
>>
>> $ mkdir /tmp/emacs.d
>> $ emacs --quick --eval '(setq user-emacs-directory "/tmp/emacs.d")'
>>
>> (package-initialize)
>> (package-refresh-contents)
>> (package-install 'scroll-restore)
>> (setq scroll-restore-jump-back t)
>> (scroll-restore-mode 1)
>>
>> M-x shell
>>
>> Now I can type the first command (c d RET), start to type the second one
>> — and the point jumps before shell prompt:
>>
>> user@local:~$ cd¦
>> cd¦user@local:~$
>>
>> (here ‘¦’ denotes cursor position)
>>
>> I could move point back to the end manually (with M-> for instance), but
>> that is pretty annoying.
>
> Could you try with ‘comint-scroll-to-bottom-on-input’ set to 'this?
> That option apparently conflicts with ‘scroll-restore-jump-back’.

Yes, this option does force any input to be typed at the end-of-buffer, 
of course.  However, the possibility to ‘C-r’ back, edit some command 
in-place and hit ‘RET’ — i. e. the possibility that this option disables 
— is exactly why I prefer shell-mode over a full-featured terminal emulator.

>> I have to mention that it would not present a huge problem if there were
>> a way disable scroll-restore-mode on per-major-mode basis.  However
>> scroll-restore-mode has only global state, no buffer-local, as far as I
>> can see.
>
> I'm afraid that ‘scroll-restore-mode’ is too simplistic in this regard.

Alas.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23546; Package emacs. Full text available.

Message received at 23546 <at> debbugs.gnu.org:


Received: (at 23546) by debbugs.gnu.org; 16 May 2016 18:44:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 16 14:44:19 2016
Received: from localhost ([127.0.0.1]:54288 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b2NV5-000444-CB
	for submit <at> debbugs.gnu.org; Mon, 16 May 2016 14:44:19 -0400
Received: from mout.gmx.net ([212.227.15.19]:65087)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1b2NV3-00043p-Ro
 for 23546 <at> debbugs.gnu.org; Mon, 16 May 2016 14:44:18 -0400
Received: from [192.168.1.101] ([212.95.7.56]) by mail.gmx.com (mrgmx003) with
 ESMTPSA (Nemesis) id 0Lfjxq-1bMUQH0MtG-00pKJu;
 Mon, 16 May 2016 10:21:03 +0200
Message-ID: <573982E5.9020005@HIDDEN>
Date: Mon, 16 May 2016 10:20:53 +0200
From: martin rudalics <rudalics@HIDDEN>
MIME-Version: 1.0
To: Dmitry Alexandrov <321942@HIDDEN>, 23546 <at> debbugs.gnu.org
Subject: Re: bug#23546: 25.1.50; scroll-restore-mode breaks comint-mode
References: <5738CD38.7030907@HIDDEN>
In-Reply-To: <5738CD38.7030907@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K0:hU0a8Nxe0uJ9cDm12enUwpozhXx4F3Rp9dzfJdFi9veuBrdCZd1
 xUVQuQ+BeCkJQ7tbRZCro6o6XFMUlhmPYEpf2eQv4qL/qMwkSfhtlE86DE+atmus+TvfVsS
 MN4H1PuScE84j+elcf+4r07VlOl1Rab8uU+X9+QRj50syJXozCyYSspRgp20eKSLgBkZ14O
 0yRLr/TR+GKpsne9p0EwA==
X-UI-Out-Filterresults: notjunk:1;V01:K0:PWoM6oNe88g=:LL8+ADYx+EPRKdtxmHBKh0
 jebTlYLmyFIrFgxue1mpkY/6utCSM0PMAiJ3EB7yY1WN+Ow+6OLJM9ZCSUfc87EiE6sbzumHz
 E7a+S3G44XZpmOGZX+Q1bwN4/xRvSNkFWkizO36tYkCpAcgDaR7AkuyaNdeAEtex9r+euXGOp
 QcijKV6TZHKMRrTJmp2iUAHAmHvqn8OtESlnh17NFsdjZBIGj+/ph1RIXkx+e/+JwpFTekbXG
 Kh3z1DY4McqEwdIoItkBqF7jgrxWyzOn4LTLewFkQs5tUUKH1mU/qo2Dyw43/yKSiNSXvB5JV
 5+NtM7gbLckQtV747V98OhfVOTTsqT6BnDaGaAXvTah33rq5JBxy3/mNThJI6KxvliZW92g+6
 IS9JyA3sMv+KKxUTOU+xbLDAXCNjnWH69srv+2pbVx/ubo4Ic1ey0+xuWDeE5Pry5tI5qh7BU
 lhBdngwxzOntpNx9tMEb8LAxmquTbrkDiUd+7linT73LGWh6vkXAAGnyWVhTsbXSfyR6DJ9bu
 Hm/MJ6VLjVp+kqwxK5otOId5qKSxjTsB47UQsNoKzJSLrk32Xhc/jhMi9HmyUZ7QjwsZ8y6Qn
 a7aBy5I9Un/Ubi3gPAT2mBLYIUl1hcVFtbZ8tFSvlEe1ss47wTRz+2Pg8ej3Hbo7bXcU0yLS2
 zayCT8RjHx+CkkYtfFtxvM+CcGXHtbIqBxXSsGg6Xzov9OyNcv5mdSCUZw6rWJhd8c19xc1bd
 QSYJhmGji3RtmK/T881nG7gitNE1NSUskiz7Hny2PIV5rt/SSOlR2Hshhmz9znpWNFXJAMQee
 2eh23AEb14lBYxP4r+6zka3NmRgDg==
X-Spam-Score: -0.1 (/)
X-Debbugs-Envelope-To: 23546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.1 (/)

 > I encountered a problem that looks like a bug to me: scroll-restore-mo=
de
 > (from elpa.gnu.org [0]) breaks comint-mode (built-in, GNU Emacs 25.1.5=
0.1).
 >
 > [0] https://elpa.gnu.org/packages/scroll-restore.html
 >
 > Steps to reproduce in a clear environment:
 >
 > $ mkdir /tmp/emacs.d
 > $ emacs --quick --eval '(setq user-emacs-directory "/tmp/emacs.d")'
 >
 > (package-initialize)
 > (package-refresh-contents)
 > (package-install 'scroll-restore)
 > (setq scroll-restore-jump-back t)
 > (scroll-restore-mode 1)
 >
 > M-x shell
 >
 > Now I can type the first command (c d RET), start to type the second o=
ne
 > =E2=80=94 and the point jumps before shell prompt:
 >
 > user@local:~$ cd=C2=A6
 > cd=C2=A6user@local:~$
 >
 > (here =E2=80=98=C2=A6=E2=80=99 denotes cursor position)
 >
 > I could move point back to the end manually (with M-> for instance), b=
ut
 > that is pretty annoying.

Could you try with =E2=80=98comint-scroll-to-bottom-on-input=E2=80=99 set=
 to 'this?
That option apparently conflicts with =E2=80=98scroll-restore-jump-back=E2=
=80=99.  (IMO
=E2=80=98scroll-restore-jump-back=E2=80=99 is much too aggressive, I neve=
r set it.)

 > I have to mention that it would not present a huge problem if there we=
re
 > a way disable scroll-restore-mode on per-major-mode basis.  However
 > scroll-restore-mode has only global state, no buffer-local, as far as =
I
 > can see.

I'm afraid that =E2=80=98scroll-restore-mode=E2=80=99 is too simplistic i=
n this regard.

Thanks, martin





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23546; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 15 May 2016 23:28:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 15 19:28:40 2016
Received: from localhost ([127.0.0.1]:53074 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b25Si-0004QO-Ch
	for submit <at> debbugs.gnu.org; Sun, 15 May 2016 19:28:40 -0400
Received: from eggs.gnu.org ([208.118.235.92]:43261)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <321942@HIDDEN>) id 1b21fW-0006tm-CL
 for submit <at> debbugs.gnu.org; Sun, 15 May 2016 15:25:38 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <321942@HIDDEN>) id 1b21fP-0003yC-Rn
 for submit <at> debbugs.gnu.org; Sun, 15 May 2016 15:25:32 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.3 required=5.0 tests=BAYES_20,
 FREEMAIL_ENVFROM_END_DIGIT,FREEMAIL_FROM,T_DKIM_INVALID autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:46199)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <321942@HIDDEN>) id 1b21fP-0003y4-P9
 for submit <at> debbugs.gnu.org; Sun, 15 May 2016 15:25:31 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:34225)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <321942@HIDDEN>) id 1b21fN-00019W-FZ
 for bug-gnu-emacs@HIDDEN; Sun, 15 May 2016 15:25:30 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <321942@HIDDEN>) id 1b21fJ-0003xg-7D
 for bug-gnu-emacs@HIDDEN; Sun, 15 May 2016 15:25:29 -0400
Received: from mail-lf0-x231.google.com ([2a00:1450:4010:c07::231]:36562)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <321942@HIDDEN>) id 1b21fI-0003xc-PH
 for bug-gnu-emacs@HIDDEN; Sun, 15 May 2016 15:25:25 -0400
Received: by mail-lf0-x231.google.com with SMTP id u64so109977144lff.3
 for <bug-gnu-emacs@HIDDEN>; Sun, 15 May 2016 12:25:24 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=to:subject:from:message-id:date:user-agent:mime-version
 :content-transfer-encoding;
 bh=bMVzoS/S7CWrQ0yYmnXo1IgCWUzjj/5U8RQk5PCrzVI=;
 b=H5ytOBlCvYidh2/yqamuGNzIRHccyazTJThuR4nLL696n+xDXoc+KomNsq3AfOxRnT
 cWSG/owAaFn9JKf21xixCGNbKMrzoDjtHt8SjxDdyQ8VDP0U+NgUoPkYPfh6KO26gJhh
 K4Nx0Lo3aIfOeSeFjftNcyiGgwH/8p45xSwRkd2ZZdA2dKf+p59t9UaT/mLfaKJzSdkK
 ++kpR7nM1vrS3NZ1b9uEgqSv5xZpoclwEBGF5mpky0cViB7b/bQgW42nW6OBYEIDrd1+
 lCGMHOdOZlTZKc/76iP24ZNc9bd3tdAPB2cST1iwk76tYsjVqtE3z3C1RuYvhtemcIfy
 AY1A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:to:subject:from:message-id:date:user-agent
 :mime-version:content-transfer-encoding;
 bh=bMVzoS/S7CWrQ0yYmnXo1IgCWUzjj/5U8RQk5PCrzVI=;
 b=TgQhOw26QqNGHBQ6F713w65wyMLXCMrcJL4tPIYqaYi0vD3rOib/ComFRU/AovBg1I
 cGar1fim+YT+ezaw2nrFGorO2wYXceewmXuLqv35szn34cwW8vcigURy+HaOepbZUStm
 phmP5GanqNze9HUGwJfUCZTHEzBqsVxhnuCpqhMg5z+Y3VaqdZnlZNE/Cumg+JMK9k+I
 0qkxwJafydYo0riaCZAfd73ktTWVBpJyZd90JODWJD2j6SPz3QPQvLYVz6MGkPwawj6e
 5g86CTl7zbpKCcAXYI4zHud67HNyR2lwp7iMKwgYmPS3ivVaG0/ChkmoRxsslA81m1ZL
 ZRyg==
X-Gm-Message-State: AOPr4FWviOFx/2AxbgLOgXdLmRLs2YYeceOU8UkBFWb4j/yrv/TuErNqsnSkhUdps/O0rg==
X-Received: by 10.25.153.137 with SMTP id b131mr6117627lfe.61.1463340324094;
 Sun, 15 May 2016 12:25:24 -0700 (PDT)
Received: from [192.168.1.132] ([178.218.27.218])
 by smtp.googlemail.com with ESMTPSA id j6sm4599868lbd.32.2016.05.15.12.25.22
 (version=TLSv1/SSLv3 cipher=OTHER);
 Sun, 15 May 2016 12:25:23 -0700 (PDT)
To: bug-gnu-emacs@HIDDEN
Subject: 25.1.50; scroll-restore-mode breaks comint-mode
From: Dmitry Alexandrov <321942@HIDDEN>
Message-ID: <5738CD38.7030907@HIDDEN>
Date: Sun, 15 May 2016 22:25:44 +0300
User-Agent: Mozilla/5.0 (X11; GNU x86_64; rv:31.0) Gecko/20100101
 Icedove/31.3.0
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -3.8 (---)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Sun, 15 May 2016 19:28:38 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.8 (---)

Hello.

I encountered a problem that looks like a bug to me: scroll-restore-mode
(from elpa.gnu.org [0]) breaks comint-mode (built-in, GNU Emacs 25.1.50.1).

[0] https://elpa.gnu.org/packages/scroll-restore.html

Steps to reproduce in a clear environment:

$ mkdir /tmp/emacs.d
$ emacs --quick --eval '(setq user-emacs-directory "/tmp/emacs.d")'

(package-initialize)
(package-refresh-contents)
(package-install 'scroll-restore)
(setq scroll-restore-jump-back t)
(scroll-restore-mode 1)

M-x shell

Now I can type the first command (c d RET), start to type the second one
— and the point jumps before shell prompt:

user@local:~$ cd¦
cd¦user@local:~$

(here ‘¦’ denotes cursor position)

I could move point back to the end manually (with M-> for instance), but
that is pretty annoying.

I have to mention that it would not present a huge problem if there were
a way disable scroll-restore-mode on per-major-mode basis.  However
scroll-restore-mode has only global state, no buffer-local, as far as I
can see.




Acknowledgement sent to Dmitry Alexandrov <321942@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#23546; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 3 Nov 2016 02:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.